/*
** File: mysqlembedded.P
** Author: Saikat Mukherjee
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 2002-2006
** 
** Licensed under the Apache License, Version 2.0 (the "License");
** you may not use this file except in compliance with the License.
** You may obtain a copy of the License at
**
**      http://www.apache.org/licenses/LICENSE-2.0
**
** Unless required by applicable law or agreed to in writing, software
** distributed under the License is distributed on an "AS IS" BASIS,
** WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
** See the License for the specific language governing permissions and
** limitations under the License.
**
*/

% This dynamically loads up the MySQL embedded server driver.

:- import bootstrap_package/2 from packaging.
:- import slash/1 from machine.
:- import fmt_write_string/3 from file_io.
:- import
	driverMySQLEmbedded_register/0,
	driverMySQLEmbedded_initialise/0,
	driverMySQLEmbedded_lib_init/0
   from mysqlembedded_driver.


:-	slash(Slash),
	fmt_write_string(Dir, 'dbdrivers%smysqlembedded', a(Slash)),
	bootstrap_package([Dir,cc], mysqlembedded_driver),
	[mysqlembedded_driver_config],
	driverMySQLEmbedded_register,
	driverMySQLEmbedded_initialise,
	driverMySQLEmbedded_lib_init. 
